---- fn_ForReport65 ----
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fn_ForReport65]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fn_ForReport65]
GO
CREATE  FUNCTION fn_ForReport65(@ObjType int, @Name nvarchar(50), @UnomID int, @LowOil bit)
returns int
as
begin
  declare @res int
  set @res = 0
  if @ObjType = 71 -- масляные выключатели
    if @LowOil = 1 -- маломасляные
    begin
      if (@UnomID = 8) OR (@UnomID = 9) set @res = 38 -- маломасляные 3-20 кВ
      else
        if @UnomID = 7 set @res = 39 -- маломасляные 35 кВ
        else
          if @UnomID = 6 -- маломасляные 110-154 кВ
            if (@Name LIKE 'ВМТ'+'[^а-я]'+'%') OR (@Name LIKE 'ВМТ') set @res = 41
            else set @res = 42
          else
            if @UnomID = 5 -- маломасляные 220 кВ
              if (@Name LIKE 'ВМТ'+'[^а-я]'+'%') OR (@Name LIKE 'ВМТ') set @res = 45
              else set @res = 46
    end
    else -- баковые
    begin
      if (@UnomID = 8) OR (@UnomID = 9) set @res = 48 -- баковые 3-20 кВ
      else
        if @UnomID = 7 set @res = 49 -- баковые 35 кВ
        else
          if @UnomID = 6 -- баковые 110-154 кВ
            if (@Name LIKE 'У'+'[^а-я]'+'%') OR (@Name LIKE 'У') set @res = 51
            else set @res = 52
          else
            if @UnomID = 5 -- баковые 220 кВ
              if (@Name LIKE 'У'+'[^а-я]'+'%') OR (@Name LIKE 'У') set @res = 55
              else set @res = 56
    end
  if @ObjType = 72 -- вакуумные выключатели
  begin
    if (@UnomID = 8) OR (@UnomID = 9) set @res = 35
    else
      if (@UnomID = 7) set @res = 36
      else
        if (@UnomID = 6) set @res = 37
  end
  if @ObjType = 73 -- воздушные выключатели
  begin
    if @UnomID = 7 set @res = 1 -- воздушные выключатели 35 кВ
    else
      if @UnomID = 6 -- воздушные выключатели 110-154 кВ
      begin
        if (@Name LIKE 'ВВБ'+'[^а-я]'+'%') OR (@Name LIKE 'ВВБ') OR (@Name LIKE 'ВВД'+'%') OR (@Name LIKE 'ВВД') set @res=3
        else
          if (@Name LIKE 'ВВБК'+'[^а-я]'+'%') OR (@Name LIKE 'ВВБК') set @res=4
          else
          if (@Name LIKE 'ВВН'+'[^а-я]'+'%') OR (@Name LIKE 'ВВН') set @res=4
          else set @res = 6
      end
      else
        if @UnomID = 5  -- воздушные выключатели 220 кВ
        begin
          if (@Name LIKE 'ВВБ'+'[^а-я]'+'%') OR (@Name LIKE 'ВВД'+'[^а-я]'+'%') OR (@Name LIKE 'ВВБ') OR (@Name LIKE 'ВВД') set @res=9
          else
            if (@Name LIKE 'ВВБК'+'[^а-я]'+'%') OR (@Name LIKE 'ВВБК') set @res=10
            else
            if (@Name LIKE 'ВВН'+'[^а-я]'+'%') OR (@Name LIKE 'ВВН') set @res=11
            else set @res = 12
        end
        else
          if @UnomID = 4  -- воздушные выключатели 330 кВ
          begin
            if (@Name LIKE 'ВВБ'+'[^а-я]'+'%') OR (@Name LIKE 'ВВД'+'[^а-я]'+'%') OR (@Name LIKE 'ВВБ') OR (@Name LIKE 'ВВД') set @res=15
            else
              if (@Name LIKE 'ВВН'+'[^а-я]'+'%') OR (@Name LIKE 'ВВ'+'[^а-я]'+'%') OR (@Name LIKE 'ВВН') OR (@Name LIKE 'ВВ') set @res=16
              else
              if (@Name LIKE 'ВНВ'+'[^а-я]'+'%') OR (@Name LIKE 'ВНВ') set @res=17
              else set @res = 18
          end
          else
            if @UnomID = 3  -- воздушные выключатели 500 кВ
            begin
              if (@Name LIKE 'ВВБ'+'[^а-я]'+'%') OR (@Name LIKE 'ВВБ') set @res=21
              else
                if (@Name LIKE 'ВВБК'+'[^а-я]'+'%') OR (@Name LIKE 'ВВБК') set @res=22
                else
                if (@Name LIKE 'ВВ'+'[^а-я]'+'%') OR (@Name LIKE 'ВВ')set @res=23
                else
                  if (@Name LIKE 'ВНВ'+'[^а-я]'+'%') OR (@Name LIKE 'ВНВ') set @res=24
                  else set @res = 25
            end
            else
              if (@UnomID = 1) OR (@UnomID = 2) -- воздушные выключатели 750-1150 кВ
              begin
                if (@Name LIKE 'ВВБ'+'[^а-я]'+'%') OR (@Name LIKE 'ВВБ') set @res=28
                else
                  if (@Name LIKE 'ВНВ'+'[^а-я]'+'%') OR (@Name LIKE 'ВНВ') set @res=29
                  else set @res = 30
              end
  end
  if @ObjType = 74 -- элегазовые выключатели
  begin
    if @UnomID = 7 set @res = 59
    else
      if @UnomID = 6 set @res = 60
      else
        if @UnomID = 5 set @res = 61
        else
          if @UnomID = 4 set @res = 62
          else
            if @UnomID = 3 set @res = 63
  end
  if @ObjType = 77 -- разъединители
  begin
    if (@UnomID = 8) OR (@UnomID = 9) set @res = 73 -- 3-20 кВ
    else
      if @UnomID = 7 -- 35 кВ
        if @Name LIKE 'КЗ'+'%' set @res = 65
        else
          if @Name LIKE 'ОД'+'%' set @res = 69
          else set @res = 74
      else
        if @UnomID = 6 -- 110-154 кВ
          if @Name LIKE 'КЗ'+'%' set @res = 66
          else
            if @Name LIKE 'ОД'+'%' set @res = 70
            else set @res = 75
        else
          if @UnomID = 5 -- 220 кВ
            if @Name LIKE 'КЗ'+'%' set @res = 67
            else
              if @Name LIKE 'ОД'+'%' set @res = 71
              else set @res = 76
          else
            if @UnomID = 4 set @res = 77 -- 330 кВ
            else
              if @UnomID = 3 set @res = 78 -- 500 кВ
              else
                if (@UnomID = 1) OR  (@UnomID = 2) set @res = 79 -- 750-1150 кВ
  end
  return @res
end
